Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Controllers/FilterController.cs
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Controllers/FilterController.cs	(revision 6185)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Controllers/FilterController.cs	(revision 6190)
@@ -26,7 +26,7 @@
 
             QueryServiceClient client = Query.GetClientFactory("okbtester", "okbtester");
-            
-
-           long[] ids =  client.GetRunIds(qm.Content);
+
+
+            long[] ids = client.GetRunIds(qm.Content);
 
             Response.Write("Found <" + ids.Count() + "> Runs.");
@@ -52,10 +52,10 @@
         /// <returns></returns>
         public ActionResult AddFilterAnd(FormCollection collection)
-        {       
+        {
             FilterModel fm = new FilterModel((CombinedFilter)Session["Content"]);
 
 
             // Add Filter
-            
+
             String idKey = null;
             String parentIdKey = null;
@@ -135,12 +135,12 @@
         {
             // Get Content from Session
-            FilterModel fm = new FilterModel((CombinedFilter)Session["Content"]);  
-            
+            FilterModel fm = new FilterModel((CombinedFilter)Session["Content"]);
+
             // Remove Filter
-           bool filterRemoved =  fm.RemoveFilter(id);
-        
+            bool filterRemoved = fm.RemoveFilter(id);
+
             // Set Content
             Session["Content"] = fm.Content;
-           
+
             return View("Index", fm);
         }
@@ -181,5 +181,5 @@
         public ActionResult Index()
         {
-           
+
             // Set submenu
             Session["SelectedSubMenu"] = "Filter";
@@ -201,6 +201,6 @@
             CombinedFilter f = (CombinedFilter)Session["Content"];
             fm.Content = f;
-            
-           
+
+
             return View(fm);
         }
Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/HLWebOKBQueryPlugin.csproj
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/HLWebOKBQueryPlugin.csproj	(revision 6185)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/HLWebOKBQueryPlugin.csproj	(revision 6190)
@@ -103,4 +103,6 @@
     <Compile Include="Models\ChartModel.cs" />
     <Compile Include="Models\Filter.cs" />
+    <Compile Include="ViewModels\ComparisonItem.cs" />
+    <Compile Include="ViewModels\ComparisonsHelper.cs" />
     <Compile Include="ViewModels\FilterModel.cs" />
     <Compile Include="Models\QueryModel.cs" />
Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/ViewModels/ComparisonItem.cs
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/ViewModels/ComparisonItem.cs	(revision 6190)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/ViewModels/ComparisonItem.cs	(revision 6190)
@@ -0,0 +1,32 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Web;
+
+namespace HLWebOKBQueryPlugin.ViewModels
+{
+    public class ComparisonItem
+    {
+        private int comparisonID;
+        private string text;
+
+        public string Text
+        {
+            get { return text; }           
+        }
+
+        public string Value
+        {
+            get { return comparisonID.ToString(); }
+        }
+
+        public ComparisonItem(int comparisonID, string text)
+        {
+
+            this.text = text;
+            this.comparisonID = comparisonID;
+        }
+
+
+    }
+}
Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/ViewModels/ComparisonsHelper.cs
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/ViewModels/ComparisonsHelper.cs	(revision 6190)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/ViewModels/ComparisonsHelper.cs	(revision 6190)
@@ -0,0 +1,65 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Web;
+
+namespace HLWebOKBQueryPlugin.ViewModels
+{
+    public class ComparisonsHelper
+    {
+        private static  String ORDINAL_COMPARISONS_LESS = "<";
+        private static  String ORDINAL_COMPARISONS_LESS_OR_EQUAL = "<=";
+        private static  String ORDINAL_COMPARISONS_EQUAL = "=";
+        private static  String ORDINAL_COMPARISONS_GREATER_OR_EQUAL = ">=";
+        private static  String ORDINAL_COMPARISONS_GREATER = ">";
+        private static  String ORDINAL_COMPARISONS_NOT_EQUAL = "<>";
+
+        private static String STRING_COMPARISONS_EQUAL = "=";
+        private static String STRING_COMPARISONS_NOT_EQUAL = "<>";
+        private static String STRING_COMPARISONS_CONTAINS = "contains";
+        private static String STRING_COMPARISONS_NOT_CONTAINS = "not contains";
+        private static String STRING_COMPARISONS_LIKE = "like";
+        private static String STRING_COMPARISONS_NOT_LIKE = "not like";
+
+        public static List<ComparisonItem> ordinalComparisons = new List<ComparisonItem>() 
+        { new ComparisonItem((int)OKBQueryService.OrdinalComparison.Less, ORDINAL_COMPARISONS_LESS),
+          new ComparisonItem((int)OKBQueryService.OrdinalComparison.LessOrEqual, ORDINAL_COMPARISONS_LESS_OR_EQUAL),
+          new ComparisonItem((int)OKBQueryService.OrdinalComparison.Equal, ORDINAL_COMPARISONS_EQUAL),
+          new ComparisonItem((int)OKBQueryService.OrdinalComparison.GreaterOrEqual, ORDINAL_COMPARISONS_GREATER_OR_EQUAL),
+          new ComparisonItem((int)OKBQueryService.OrdinalComparison.Greater, ORDINAL_COMPARISONS_GREATER),
+          new ComparisonItem((int)OKBQueryService.OrdinalComparison.NotEqual, ORDINAL_COMPARISONS_NOT_EQUAL)
+        };
+        public static List<ComparisonItem> stringComparisons = new List<ComparisonItem>() {
+           new ComparisonItem((int)OKBQueryService.StringComparison.Equal, STRING_COMPARISONS_EQUAL),
+           new ComparisonItem((int)OKBQueryService.StringComparison.NotLike, STRING_COMPARISONS_NOT_EQUAL),
+           new ComparisonItem((int)OKBQueryService.StringComparison.Contains, STRING_COMPARISONS_CONTAINS),
+           new ComparisonItem((int)OKBQueryService.StringComparison.NotContains, STRING_COMPARISONS_NOT_CONTAINS),
+           new ComparisonItem((int)OKBQueryService.StringComparison.Like, STRING_COMPARISONS_LIKE),
+           new ComparisonItem((int)OKBQueryService.StringComparison.NotLike, STRING_COMPARISONS_NOT_LIKE)
+         };
+
+
+        public static OKBQueryService.StringComparison GetStringComparisonForValue(string comparisonValue)
+        {
+            int v = Int32.Parse(comparisonValue);
+
+            switch (v)
+            {
+                case (int)OKBQueryService.StringComparison.Equal:
+                    return OKBQueryService.StringComparison.Equal;
+                case (int)OKBQueryService.StringComparison.Contains:
+                    return OKBQueryService.StringComparison.Contains;
+                case (int)OKBQueryService.StringComparison.Like:
+                    return OKBQueryService.StringComparison.Like;
+                case (int)OKBQueryService.StringComparison.NotContains:
+                    return OKBQueryService.StringComparison.NotContains;
+                case (int)OKBQueryService.StringComparison.NotEqual:
+                    return OKBQueryService.StringComparison.NotEqual;
+                case (int)OKBQueryService.StringComparison.NotLike:
+                    return OKBQueryService.StringComparison.NotLike;
+                default:
+                    return OKBQueryService.StringComparison.Equal; //TODO 
+            }
+        }
+    }
+}
Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/ViewModels/FilterModel.cs
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/ViewModels/FilterModel.cs	(revision 6185)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/ViewModels/FilterModel.cs	(revision 6190)
@@ -5,4 +5,5 @@
 using HLWebOKBQueryPlugin.OKBQueryService;
 using HLWebOKBQueryPlugin.Helpers;
+using HLWebOKBQueryPlugin.ViewModels;
 
 namespace HLWebOKBQueryPlugin.Models
@@ -15,4 +16,6 @@
     public class FilterModel
     {
+        
+
 
         public static string ComboboxName { get { return "filtersCombobox"; } }
@@ -20,5 +23,5 @@
         public static string ValueTextbox { get { return "valueTextbox"; } }
         public static string ValueDropDownList { get { return "valueDropDownList"; } }
-
+        public static string ComparisonDropDownList { get { return "comparisonDropDownList"; } }
 
         /// <summary>
@@ -53,4 +56,31 @@
 
 
+        public static List<ComparisonItem> OrdinalComparisons 
+        {
+            get { return ComparisonsHelper.ordinalComparisons; }
+        }
+
+        public static List<ComparisonItem> StringComparisons
+        {
+            get { return ComparisonsHelper.stringComparisons; }
+        }
+        
+
+        //"<";
+        //else if (Content.Comparison == OrdinalComparison.LessOrEqual)
+        //  comparisonComboBox.SelectedItem = "<=";
+        //else if (Content.Comparison == OrdinalComparison.Equal)
+        //  comparisonComboBox.SelectedItem = "=";
+        //else if (Content.Comparison == OrdinalComparison.GreaterOrEqual)
+        //  comparisonComboBox.SelectedItem = ">=";
+        //else if (Content.Comparison == OrdinalComparison.Greater)
+        //  comparisonComboBox.SelectedItem = ">";
+        //else if (Content.Comparison == OrdinalComparison.NotEqual)
+        //  comparisonComboBox.SelectedItem = "<>"
+
+
+
+
+
         /// <summary>
         /// Available Filters
@@ -61,5 +91,11 @@
             {
                 QueryServiceClient client = Query.GetClientFactory("okbtester", "okbtester");
-                return client.GetFilters().ToList<Filter>();
+                Filter[] filters = client.GetFilters();
+
+                if (filters == null)
+                {
+                    return new List<Filter>();
+                }
+                return filters.ToList<Filter>();
             }
         }
@@ -87,5 +123,5 @@
         public CombinedFilter Content { get; set; }
 
-      
+
 
         /// <summary>
@@ -171,5 +207,10 @@
                                 if (kvp.Key.Equals(FilterModel.ValueTextbox))
                                 {
-                                    ((StringComparisonFilter)f).Value = kvp.Value;
+                                    ((StringComparisonFilter)f).Value = kvp.Value + "111";
+                                }
+                                else if (kvp.Key.Equals(FilterModel.ComparisonDropDownList))
+                                {
+                                    ((StringComparisonFilter)f).Value = ((StringComparisonFilter)f).Value + "222";
+                                    ((StringComparisonFilter)f).Comparison = ComparisonsHelper.GetStringComparisonForValue(kvp.Value);
                                 }
                                 // To this for alle keys
Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Filter/Filters.ascx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Filter/Filters.ascx	(revision 6185)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Filter/Filters.ascx	(revision 6190)
@@ -40,5 +40,5 @@
     <% StringComparisonFilter filter = ((StringComparisonFilter)f); %>
     <%: Html.Label(filter.Label)%>
-    <%: Html.Label("=")%>
+    <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.StringComparisons,"Value","Text", filter.Comparison))%>   
     <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, (filter.Value))%>
     <% }
@@ -47,5 +47,5 @@
     <% NameStringComparisonFilter filter = ((NameStringComparisonFilter)f); %>
     <%: Html.Label(filter.Label)%>
-    <%: Html.Label("=" + f.Id)%>
+    <%: Html.Label("=")%>
     <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, filter.Value)%>
     <% }
@@ -61,4 +61,5 @@
     <% NameEqualityComparisonByteArrayFilter filter = ((NameEqualityComparisonByteArrayFilter)f); %>
     <%: Html.Label(filter.Label)%>
+      <%: Html.Label("teby")%>
     <% }
 else if ("NameEqualityComparisonBoolFilter".Equals(f.GetType().Name))
@@ -67,5 +68,5 @@
     %>
     <%: Html.Label(filter.Label)%>
-    <%: Html.Label("is")%>
+    <%: Html.Label("is") %>
     <%: Html.DropDownList(f.Id + "." + FilterModel.ValueDropDownList, new SelectList(((FilterModel)Model).BoolStates, filter.Value))%>
     <% }
@@ -74,5 +75,6 @@
     <% NameOrdinalComparisonIntFilter filter = ((NameOrdinalComparisonIntFilter)f);   %>
     <%: Html.Label(filter.Label)%>
-    <%: Html.Label("is")%>
+    <%: Html.DropDownList(f.Id + "." + FilterModel.ValueDropDownList, new SelectList(FilterModel.OrdinalComparisons,"Value","Text", filter.Comparison))%>
+    <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, filter.Value)%>
     <% }
 else if ("NameStringComparisonAvailableValuesFilter".Equals(f.GetType().Name))
@@ -87,5 +89,5 @@
     <% NameOrdinalComparisonDoubleFilter filter = ((NameOrdinalComparisonDoubleFilter)f);   %>
     <%: Html.Label(filter.Label)%>
-    <%: Html.Label("=")%>
+    <%: Html.Label("<")%>
     <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, filter.Value)%>
     <% }
@@ -94,5 +96,5 @@
     <% NameOrdinalComparisonFloatFilter filter = ((NameOrdinalComparisonFloatFilter)f);   %>
     <%: Html.Label(filter.Label)%>
-    <%: Html.Label("=")%>
+    <%: Html.Label("<")%>
     <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, filter.Value)%>
     <% }
@@ -101,5 +103,5 @@
     <% NameOrdinalComparisonLongFilter filter = ((NameOrdinalComparisonLongFilter)f);   %>
     <%: Html.Label(filter.Label)%>
-    <%: Html.Label("=")%>
+    <%: Html.Label("<")%>
     <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, filter.Value)%>
     <% }                 