Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/ViewModels/ComparisonsHelper.cs
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/ViewModels/ComparisonsHelper.cs	(revision 6190)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/ViewModels/ComparisonsHelper.cs	(revision 6191)
@@ -32,5 +32,5 @@
         public static List<ComparisonItem> stringComparisons = new List<ComparisonItem>() {
            new ComparisonItem((int)OKBQueryService.StringComparison.Equal, STRING_COMPARISONS_EQUAL),
-           new ComparisonItem((int)OKBQueryService.StringComparison.NotLike, STRING_COMPARISONS_NOT_EQUAL),
+           new ComparisonItem((int)OKBQueryService.StringComparison.NotEqual, STRING_COMPARISONS_NOT_EQUAL),
            new ComparisonItem((int)OKBQueryService.StringComparison.Contains, STRING_COMPARISONS_CONTAINS),
            new ComparisonItem((int)OKBQueryService.StringComparison.NotContains, STRING_COMPARISONS_NOT_CONTAINS),
@@ -38,4 +38,27 @@
            new ComparisonItem((int)OKBQueryService.StringComparison.NotLike, STRING_COMPARISONS_NOT_LIKE)
          };
+
+
+        public static String GetValueForStringComparision(OKBQueryService.StringComparison comparisionValue)
+        {
+            switch (comparisionValue)
+            {
+                case OKBQueryService.StringComparison.Equal:
+                    return STRING_COMPARISONS_EQUAL;
+                case OKBQueryService.StringComparison.Contains:
+                    return STRING_COMPARISONS_CONTAINS;
+                case OKBQueryService.StringComparison.Like:
+                    return STRING_COMPARISONS_LIKE;
+                case OKBQueryService.StringComparison.NotContains:
+                    return STRING_COMPARISONS_NOT_CONTAINS;
+                case OKBQueryService.StringComparison.NotEqual:
+                    return STRING_COMPARISONS_NOT_EQUAL;
+                case OKBQueryService.StringComparison.NotLike:
+                    return STRING_COMPARISONS_NOT_LIKE;
+                default:
+                    return STRING_COMPARISONS_EQUAL; //TODO 
+            }
+        }
+
 
 
Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/ViewModels/FilterModel.cs
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/ViewModels/FilterModel.cs	(revision 6190)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/ViewModels/FilterModel.cs	(revision 6191)
@@ -201,16 +201,26 @@
                     if (dict != null)
                     {
+                      
                         foreach (KeyValuePair<string, string> kvp in dict)
                         {
                             if ("StringComparisonFilter".Equals(f.GetType().Name))
                             {
+
+                                ((StringComparisonFilter)f).Value = kvp.Value;
+
                                 if (kvp.Key.Equals(FilterModel.ValueTextbox))
                                 {
-                                    ((StringComparisonFilter)f).Value = kvp.Value + "111";
+                                    ((StringComparisonFilter)f).Value = kvp.Value; // +"111";
+
+                                    //((StringComparisonFilter)f).Value = ((StringComparisonFilter)f).Value;
+                                  //  ((StringComparisonFilter)f).Comparison = ((StringComparisonFilter)f).Comparison;
+
+
                                 }
                                 else if (kvp.Key.Equals(FilterModel.ComparisonDropDownList))
                                 {
-                                    ((StringComparisonFilter)f).Value = ((StringComparisonFilter)f).Value + "222";
+                                  //  ((StringComparisonFilter)f).Value = ((StringComparisonFilter)f).Value;
                                     ((StringComparisonFilter)f).Comparison = ComparisonsHelper.GetStringComparisonForValue(kvp.Value);
+                                  
                                 }
                                 // To this for alle keys
@@ -221,5 +231,10 @@
                                 // To this for all filters
                             }
+
+                            
                         }
+                        StringComparisonFilter scf = (StringComparisonFilter)f;
+                        //throw new Exception("Huhu ich bin doof");
+                        
                     }
                 }
Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Filter/Filters.ascx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Filter/Filters.ascx	(revision 6190)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Filter/Filters.ascx	(revision 6191)
@@ -2,4 +2,6 @@
 <%@ Import Namespace="HLWebOKBQueryPlugin.Models" %>
 <%@ Import Namespace="HLWebOKBQueryPlugin.OKBQueryService" %>
+<%@ Import Namespace="HLWebOKBQueryPlugin.ViewModels" %>
+
 <!-- Put all into a form that calls the "AddFilter" Action-->
 <div><table>
@@ -40,5 +42,5 @@
     <% StringComparisonFilter filter = ((StringComparisonFilter)f); %>
     <%: Html.Label(filter.Label)%>
-    <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.StringComparisons,"Value","Text", filter.Comparison))%>   
+    <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.StringComparisons, "Value", "Text",(int)filter.Comparison))%>   
     <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, (filter.Value))%>
     <% }