Index: branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Auxiliary/TypeLoader.cs
===================================================================
--- branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Auxiliary/TypeLoader.cs	(revision 6206)
+++ branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Auxiliary/TypeLoader.cs	(revision 6210)
@@ -27,5 +27,5 @@
 namespace HeuristicLab.Persistence.Auxiliary {
 
-  internal class TypeLoader {
+  internal static class TypeLoader {
 
     public static Type Load(string typeNameString) {
@@ -33,6 +33,5 @@
       try {
         type = Type.GetType(typeNameString, true);
-      }
-      catch (Exception) {
+      } catch (Exception) {
         Logger.Warn(String.Format(
           "Cannot load type \"{0}\", falling back to partial name", typeNameString));
@@ -44,6 +43,5 @@
 #pragma warning restore 0618
           type = a.GetType(typeName.ToString(false, false), true);
-        }
-        catch (Exception) {
+        } catch (Exception) {
           throw new PersistenceException(String.Format(
             "Could not load type \"{0}\"",
@@ -63,9 +61,7 @@
               typeNameString,
               type.AssemblyQualifiedName));
-        }
-        catch (PersistenceException) {
+        } catch (PersistenceException) {
           throw;
-        }
-        catch (Exception e) {
+        } catch (Exception e) {
           Logger.Warn(String.Format(
             "Could not perform version check requested type was {0} while loaded type is {1}:",
Index: branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Auxiliary/TypeName.cs
===================================================================
--- branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Auxiliary/TypeName.cs	(revision 6206)
+++ branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Auxiliary/TypeName.cs	(revision 6210)
@@ -84,5 +84,5 @@
     /// <value>The assembly attribues.</value>
     [Storable]
-    public Dictionary<string, string> AssemblyAttribues { get; internal set; }
+    public Dictionary<string, string> AssemblyAttributes { get; internal set; }
 
     /// <summary>
@@ -108,5 +108,5 @@
       GenericArgs = new List<TypeName>();
       MemoryMagic = "";
-      AssemblyAttribues = new Dictionary<string, string>();
+      AssemblyAttributes = new Dictionary<string, string>();
     }
 
@@ -155,5 +155,5 @@
         sb.Append(", ").Append(AssemblyName);
         if (full)
-          foreach (var property in AssemblyAttribues)
+          foreach (var property in AssemblyAttributes)
             sb.Append(", ").Append(property.Key).Append('=').Append(property.Value);
       }
@@ -224,6 +224,6 @@
           throw new Exception("Cannot compare versions of different types");
         if (CompareVersions(
-          this.AssemblyAttribues["Version"],
-          typeName.AssemblyAttribues["Version"]) > 0)
+          this.AssemblyAttributes["Version"],
+          typeName.AssemblyAttributes["Version"]) > 0)
           return true;
         IEnumerator<TypeName> thisIt = this.GenericArgs.GetEnumerator();
@@ -255,6 +255,6 @@
           this.AssemblyName != typeName.AssemblyName)
           throw new Exception("Cannot compare versions of different types");
-        Version thisVersion = new Version(this.AssemblyAttribues["Version"]);
-        Version tVersion = new Version(typeName.AssemblyAttribues["Version"]);
+        Version thisVersion = new Version(this.AssemblyAttributes["Version"]);
+        Version tVersion = new Version(typeName.AssemblyAttributes["Version"]);
         if (this.AssemblyName == "mscorlib" &&
           (thisVersion.Major == 2 || thisVersion.Major == 4) &&
Index: branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Auxiliary/TypeNameParser.cs
===================================================================
--- branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Auxiliary/TypeNameParser.cs	(revision 6206)
+++ branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Auxiliary/TypeNameParser.cs	(revision 6210)
@@ -246,5 +246,5 @@
           KeyValuePair<string, string> property =
             TransformAssemblyProperty();
-          typeName.AssemblyAttribues.Add(property.Key, property.Value);
+          typeName.AssemblyAttributes.Add(property.Key, property.Value);
         }
       }
Index: branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Default/CompositeSerializers/HashSetSerializer.cs
===================================================================
--- branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Default/CompositeSerializers/HashSetSerializer.cs	(revision 6206)
+++ branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Default/CompositeSerializers/HashSetSerializer.cs	(revision 6210)
@@ -73,6 +73,4 @@
       }
     }
-
-    public object HashSet { get; set; }
   }
 }
Index: branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Tests/UseCases.cs
===================================================================
--- branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Tests/UseCases.cs	(revision 6206)
+++ branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Tests/UseCases.cs	(revision 6210)
@@ -863,5 +863,5 @@
         Assert.Fail("Exception expected");
       } catch (PersistenceException pe) {
-        Assert.AreEqual(pe.InnerException.Message, "this constructor will always fail");
+        Assert.AreEqual("this constructor will always fail", pe.InnerException.Message);
       }
     }